# ############################################################# app-cwinkelm ##

project = app-cwinkelm
import = libDG
executable = normTest
object = elasticityTensor.o bilinearForm.o linearForm.o normTest.o equivalentStress.o periodicSquare.o ../app-fvdgfem/pslogger.o

has_direct_solver_temp = false

ifeq ($(HAS_UMFPACK),true)
	has_direct_solver_temp = true
endif
ifeq ($(HAS_SuperLU), true)
	has_direct_solver_temp = true
endif
ifeq ($(has_direct_solver_temp), true)
  ifeq ($(HAS_ARPACK),true)
    object += wave_eqn_2d.o elasticity.o mixed.o
    executable += wave_eqn_2d elasticity mixed
  endif
endif

include $(CONCEPTSDIR)/makesupport/generic.mk

# tests
test-apps: normTest
	@echo testing DG 2D
	ln -sf ../../../app-cwinkelm/0101.* .
	./normTest > normTest.out

# dependencies
VPATH += $(CONCEPTSDIR)/builds/$(config)/lib
LIBS = $(call extractLibs, libDG)

normTest: normTest.o $(call expand, libDG)
wave_eqn_2d: bilinearForm.o linearForm.o wave_eqn_2d.o $(call expand, libDG) 
elasticity: elasticityTensor.o bilinearForm.o linearForm.o equivalentStress.o elasticity.o ../app-fvdgfem/pslogger.o periodicSquare.o $(call expand, libDG)
mixed: elasticityTensor.o bilinearForm.o linearForm.o equivalentStress.o mixed.o ../app-fvdgfem/pslogger.o periodicSquare.o $(call expand, libDG)
