#include <iostream>

class Cumbersome {
public:
  virtual void print() {};
};

class Ogi : public Cumbersome {
  virtual void print() {};
};

class Base {
public:
  Base(int a) : a_(a) { std::cout << "Base constructor" << std::endl; };
  virtual void print() { std::cout << a_ << std::endl; };
private:
  int a_;
};

class Failer {
public:
  Failer(Cumbersome& c) : c_(dynamic_cast<Ogi&>(c)) {};
private:
  Cumbersome& c_;
};

class Derived : public Base {
public:
  Derived(int a, int b, Cumbersome c) : Base(a), b_(b), c_(c) {
     std::cout << "Derived constructor" << std::endl;
  };
  Derived(Base& base, Cumbersome c) : Base(base), b_(0), c_(c) {};
  virtual void print() { std::cout << b_ << std::endl; };
private:
  int b_;
  Failer c_;
};

int main(int argc, char** argv) {
  Cumbersome adolf;
  Derived m(5, 7, adolf);
  Derived n(m);
  n.print();
  return 0;
}
