/* This application shows how to write an application including a tutorial.

   We need just one include file.
*/
#include "geometry/connector.hh"

/* Currently, only abstract classes are defined in the library.
   Therefore, we need to create a derived class with no abstract
   members.
*/
namespace concepts {
  class test : public Connector {
  public:
    test() : Connector(0, 0) {}
    Connector* child(uint, bool = 0) { return 0; }
    const Connector* child(uint) const { return 0; }
    virtual std::ostream& info(std::ostream& os) const;
  };

  std::ostream& test::info(std::ostream& os) const {
    return os << "Hello World.";
  }
}

/* Here is our short main program.
*/
int main(int, char**) {
  concepts::test t;
  std::cout << t << std::endl;

  return 0;
}
