# ############################################################# applications ##

project = applications
import = lib liblinearFEM libDG # libhp2D
executable = connApp inputoutput fem1D fem2D \
	fem3D h-fem \
	linearFEM2d linearFEM1d linearDG1d hpFEM2d
#	topologyDotty fem1D-sol
object = connApp.o inputoutput.o fem1D.o fem2D.o \
	fem3D.o h-fem.o square.o \
	linearFEM2d.o linearFEM1d.o linearDG1d.o hpFEM2d.o
#	topologyDotty.o square.o fem1D-sol.o

ifeq ($(HAS_PETSC),true)
executable += fem2D-sol fem2D-neumann fem2D-neumann-noabs fem3D-sol \
	linearFEM3d
object += fem2D-sol.o fem2D-neumann.o fem2D-neumann-noabs.o fem3D-sol.o \
	linearFEM3d.o
endif

include $(CONCEPTSDIR)/makesupport/generic.mk

# tests

test-apps: $(executable)
	@echo testing connApp
	./connApp > connApp.out

	@echo testing inputoutput
	./inputoutput -f ../../../applications/inputoutput.concepts > \
	inputoutput-stdout.out

	@echo testing linearFEM1d
	./linearFEM1d -l 3 > linearFEM1d.out

	@echo testing linearFEM2d
	./linearFEM2d > linearFEM2d.out

	@echo testing linearDG1d
	./linearDG1d -l 3 > linearDG1d.out

# dependencies
VPATH += $(CONCEPTSDIR)/builds/$(config)/lib
LIBS = $(call extractLibs, lib)

connApp: connApp.o $(call expand, lib)

inputoutput: inputoutput.o $(call expand, lib)

fem1D: fem1D.o $(call expand, lib)
fem1D-sol: fem1D-sol.o $(call expand, lib)

fem2D: fem2D.o $(call expand, lib)
fem2D-sol: fem2D-sol.o $(call expand, lib)
fem2D-neumann: fem2D-neumann.o $(call expand, lib)
fem2D-neumann-noabs: fem2D-neumann-noabs.o $(call expand, lib)

fem3D: fem3D.o $(call expand, lib)
fem3D-sol: fem3D-sol.o $(call expand, lib)

h-fem: h-fem.o $(call expand, lib)

linearFEM1d: LIBS = $(call extractLibs, liblinearFEM)
linearFEM1d: linearFEM1d.o $(call expand, liblinearFEM)

linearFEM2d: LIBS = $(call extractLibs, liblinearFEM)
linearFEM2d: linearFEM2d.o $(call expand, liblinearFEM)

linearFEM3d: LIBS = $(call extractLibs, liblinearFEM)
linearFEM3d: linearFEM3d.o $(call expand, liblinearFEM)

# topologyDotty: square.o topologyDotty.o $(call expand, libhp2D)

linearDG1d: LIBS = $(call extractLibs, libDG)
linearDG1d: linearDG1d.o $(call expand, libDG)

hpFEM2d: LIBS = $(call extractLibs, libhp2D)
hpFEM2d: hpFEM2d.o $(call expand, libhp2D)
