// exception when opening a file etc.

#ifndef fileExc_hh
#define fileExc_hh

#include "exceptions.hh"

namespace concepts {

  // ********************************************************* FileOpenError **

  /** Indicates that there were problems in a file open operation.
      @author Philipp Frauenfelder, 2002.
  */
  class FileOpenError : public MissingFeature {
  public:
    /** Constructor.
	@param file The name of the file
    */
    FileOpenError(const std::string& file) throw();
  protected:
    virtual std::ostream& info(std::ostream& os) const throw();
  };

}

#endif // fileExc_hh
