// exception when a fortran routine returns a info != 0 flag

#include "fortranException.hh"
#include <sstream>

namespace concepts {

  // ****************************************************** FortranException **

  FortranException::FortranException(const int info,
				     const std::string& name) throw() :
    MissingFeature(name) {
    feature_.insert(0, "'");
    std::stringstream infoMsg;
    infoMsg << "': info = " << info << std::ends;
    feature_ += infoMsg.str();
  }

  std::ostream& FortranException::info(std::ostream& os) const throw() {
    return os << '[' << file_ << ", line " << line_ << "] " << function_ 
	      << " -- error from FORTRAN routine " << feature_;
  }

} // namespace concepts
