// exception when an iterative method does not converge

#include "noConvException.hh"

namespace concepts {

  // ********************************************************* NoConvergence **

  NoConvergence::NoConvergence(const std::string& errMsg) throw() :
    MissingFeature(errMsg) {}

  std::ostream& NoConvergence::info(std::ostream& os) const throw() {
    return os << '[' << file_ << ", line " << line_ << "] " << function_ 
	      << " -- no convergence: " << feature_;
  }

} // namespace concepts
