// testint class Point

#ifndef testPoint_hh
#define testPoint_hh

#include "testcase.hh"

namespace test {

  /** Testing concepts::Point
      @author Philipp Frauenfelder, 2003
  */
  class PointTest : public TestCase {
  public:
    virtual ~PointTest() {}
    virtual void run();

    /// @name Test routines
    //@{
    /// Tests constructor of Point<2> and Point<3>
    void testConstr();
    /// Tests inner products
    void testDotProduct();
    /// Tests outer products
    void testCrossProduct();
    /// Tests sum of Points
    void testSum();
    //}@
  };

  /** Testing concepts::Mapping
      @author Philipp Frauenfelder, 2003
  */
  class MappingTest : public TestCase {
  public:
    virtual ~MappingTest() {}
    virtual void run();

    /// @name Test routines
    //@{
    /// Tests constructor of Mapping<2>
    void testContr();
    /// Tests determinant
    void testDet();
    /// Tests inverse
    void testInv();
    /// Tests transpose
    void testTranspose();
    /// Tests mapping
    void testMapping();
    /// Tests scaleRow
    void testScaleRows();
    /// Tests scaleColumn
    void testScaleColumns();
    /// Tests rank 1 product
    void testRank1Prod();
    //}@
  };

} // namespace test

#endif // testPoint_hh
