/* vectors and matrices for 2D and 3D
 * forward declarations
 */

#ifndef vectMatrForward_hh
#define vectMatrForward_hh

#include "typedefs.hh"

namespace concepts {

  // forward declarations
  template<class F, int dim>
  class Point;

  typedef Point<Real, 2> Real2d;
  typedef Point<Real, 3> Real3d;

  template<int dim>
  class UnitNd;

  typedef UnitNd<2> Unit2d;
  typedef UnitNd<3> Unit3d;

  template<class F, int dim>
  class Mapping;

  typedef Mapping<Real, 2> MapReal2d;
  typedef Mapping<Real, 3> MapReal3d;

} // namespace concepts

#endif // vectMatrForward_hh
