// element for constraints

#include "element.hh"
#include "basics/typedefs.hh"
#include "basics/debug.hh"

// debugging

#define constrElmConstr_D 0

namespace constraints {

  // *************************************************************** Element **

  template<typename F>
  Element<F>::Element(concepts::Element<F>& elm, concepts::TColumn<F>* T) :
    elm_(elm), T_(T) {
    DEBUGL(constrElmConstr_D, elm << " has " << T_);
  }

  template<typename F>
  Element<F>::~Element() {}

  template<typename F>
  std::ostream& Element<F>::info(std::ostream& os) const {
    return os << "Element(" << elm_ << ", " << T_ << ')';
  }

  using concepts::Real;
  template class Element<Real>;

} // namespace constraints
