// fabric for eigensolver InexactInv

#include "inexactFabric.hh"
#include "operator/compositions.hh"

namespace eigensolver {

  // ****************************************************** InexactInvFabric **

  InexactInvFabric::~InexactInvFabric() {}

  InexactInv<Real>& InexactInvFabric::operator()
    (concepts::Operator<Real>& stiff, concepts::Operator<Real>& mass) {
    solver_.reset(new InexactInv<Real>(stiff, mass, EFguess_, innerTol_,
				       innerMax_, outerTol_, outerMax_));
    return *solver_;
  }

  std::ostream& InexactInvFabric::info(std::ostream& os) const {
    if (solver_.get())
      return os << *solver_;
    else
      return os << "InexactInvFabric(" << solver_.get() << ')';
  }

} // namespace eigensolver
