# ############################################################## eigensolver ##

project = eigensolver
import = basics operator function toolbox sparseqr
object = eigens.o constrained.o

ifeq ($(HAS_JDBSym),true)
object += jdbsym.o jdbsymFabric.o
CPPFLAGS += -I$(JDBSym_INC_PATH)
endif

ifeq ($(HAS_ARPACK),true)
object += ARPACKdsaupd.o arpackFabric.o ARPACKdnaupd.o
endif

ifeq ($(HAS_PETSC),true)
object += inexactInv.o inexactFabric.o
endif

ifeq ($(HAS_UMFPACK),true)
CPPFLAGS += -DHAS_UMFPACK
endif

ifeq ($(HAS_PARDISO),true)
CPPFLAGS += -DHAS_PARDISO
endif

$(shell rm -f libraries && touch libraries)

# must be the first here and the order must not be changed!!
ifeq ($(HAS_ARPACK),true)
$(shell echo -L$(ARPACK_LIB_PATH) $(ARPACK_LIB) >> libraries)
endif

ifeq ($(HAS_JDBSym),true)
$(shell echo -L$(JDBSym_LIB_PATH) $(JDBSym_LIB) >> libraries)
endif

include $(CONCEPTSDIR)/makesupport/generic.mk
