# #################################################### eigensolver testsuite ##

project = eigensolver/testsuite
import = space basics operator eigensolver function sparseqr toolbox
executable =
object =

ifeq ($(HAS_JDBSym),true)
CPPFLAGS += -DHAS_JDBSym
executable += jdbsym
object += jdbsym.o
endif

ifeq ($(HAS_ARPACK),true)
CPPFLAGS += -DHAS_ARPACK
executable += dsdrv3 arpack
object += dsdrv3.o arpack.o
endif

ifeq ($(HAS_PETSC),true)
executable = inexactInv constrained
object = inexactInv.o constrained.o
endif

include $(CONCEPTSDIR)/makesupport/generic.mk

toolbox_o =  toolbox/resourceMonitor.o toolbox/inputOutput.o toolbox/input.yy.o toolbox/input.tab.o

# dependencies

dsdrv3: LIBS = $(call extractLibs,$(shell cat ../libraries) $(shell cat ../../operator/libraries)) -lfl
dsdrv3: dsdrv3.o $(call expand, basics function space eigensolver sparseqr operator $(toolbox_o))

arpack: LIBS = $(call extractLibs,$(shell cat ../libraries) $(shell cat ../../operator/libraries)) -lfl
arpack: arpack.o $(call expand, basics function space eigensolver sparseqr operator $(toolbox_o))

jdbsym: LIBS = $(call extractLibs,$(shell cat ../libraries) $(shell cat ../../operator/libraries)) -lfl
jdbsym: jdbsym.o $(call expand, basics function space eigensolver sparseqr operator $(toolbox_o))

inexactInv: LIBS = $(call extractLibs,$(shell cat ../libraries) $(shell cat ../../operator/libraries)) -lfl
inexactInv: inexactInv.o $(call expand, basics function space eigensolver sparseqr operator $(toolbox_o))

constrained: LIBS = $(call extractLibs,$(shell cat ../libraries) $(shell cat ../../operator/libraries)) -lfl
constrained: constrained.o $(call expand, basics function space operator $(toolbox_o) eigensolver sparseqr)
