/* testsuite for Vector
 */

#include <cstdlib>
#include "basics/exceptions.hh"
#include "function.hh"

int main(int argc, char** argv) {

  using namespace concepts;

  try {
    DummySpace<Real> spc(10);
    std::cout << spc << std::endl;

    Vector<Real> v(spc);
    for (uint i = 0; i < spc.dim(); ++i)
      v[i] = 1.+i;
    std::cout << v << std::endl;
    std::cout << "l1 = " << v.l1() << std::endl;
    std::cout << "l2 = " << v.l2() << std::endl;
    std::cout << "max = " << v.max() << std::endl;

    v.write("vector.test");
    Vector<Real> v2(spc, "vector.test");
    std::cout << v2 << std::endl;
    Vector<Real> v3(spc, "../../../../function/testsuite/vector.test");
    std::cout << v3 << std::endl;
    std::system("diff vector.test ../../../../function/testsuite/vector.test");

    DummySpace<Cmplx> spcC(10);
    std::cout << spcC << std::endl;

    Vector<Cmplx> vC(spcC);
    for (uint i = 0; i < spcC.dim(); ++i)
      vC[i] = Cmplx(1.,i);
    std::cout << vC << std::endl;
    std::cout << "l1 = " << vC.l1() << std::endl;
    std::cout << "l2 = " << vC.l2() << std::endl;
    std::cout << "max = " << vC.max() << std::endl;

    vC.write("vectorC.test");
    Vector<Cmplx> vC2(spcC, "vectorC.test");
    std::cout << vC2 << std::endl;
    Vector<Cmplx> vC3(spcC, "../../../../function/testsuite/vectorC.test");
    std::cout << vC3 << std::endl;
    std::system
      ("diff vectorC.test ../../../../function/testsuite/vectorC.test");
  }
  catch (ExceptionBase& e) {
    std::cout << e << std::endl;
  }

  return 0;
}
