/* Function derivation: Vector, stores the values in an array
 */

#include "vector.cc"

namespace concepts {

  // ************************************************************** Vector **

  template<>
  Real Vector<Cmplx>::l1() {
    Real  l1 = 0.0;
    Cmplx* v = v_;
    for (uint i = n_; i; --i) { l1 += std::abs(*v++); }
    return l1;
  }

  template<>
  Real Vector<Cmplx>::l2_2() const {
    Real  l2_2 = 0.0;
    Cmplx* v = v_;
    for (uint i = n_; i; --i) { l2_2 += std::norm(*v++); }
    return l2_2;
  }

  template<>
  Real Vector<Cmplx>::max() {
    Real  max = 0.0;
    Cmplx* v = v_;
    for (uint i = n_; i; --i) { 
      Real foo = std::abs(*v++);
      if (foo > max) max = foo;
    }
    return max;
  }

  template class Vector<Cmplx>;

} // namespace concepts
