/* Function derivation: Vector, stores the values in an array
 */

#include "vector.cc"

namespace concepts {

  // ************************************************************** Vector **

  template<>
  Real Vector<Real>::l1() {

    Real  l1 = 0.0;
    Real* v = v_;
    for (uint i = n_; i; --i) { l1 += *v < 0.0 ? -*v : *v; ++v; }

    return l1;
  }

  template<>
  Real Vector<Real>::l2_2() const {

    Real  l2_2 = 0.0;
    Real* v = v_;
    for (uint i = n_; i; --i) { l2_2 += *v * *v; ++v; }

    return l2_2;
  }

  template<>
  Real Vector<Real>::max() {

    Real  max = 0.0;
    Real* v = v_;
    for (uint i = n_; i; --i) { 
      Real foo = *v++; if (foo < 0.0) foo = -foo;
      if (foo > max) max = foo;
    }

    return max;
  }

  template class Vector<Real>;

} // namespace concepts
