/* testsuite for 2D cells
 */

#include <memory>
#include "basics/exceptions.hh"
#include "geometry.hh"

int main(int, char**) {

  using namespace concepts;

  try {
    Import2dMesh mesh1("../../../../geometry/testsuite/Coordinates2D.dat",
		       "../../../../geometry/testsuite/Elements2D.dat",
		       "../../../../geometry/testsuite/Dirichlet2D.dat");
    std::cout << mesh1 << std::endl;
    std::auto_ptr<Scan2> sc(mesh1.scan());
    while (*sc) {
      Cell2& cell = (*sc)++;
      std::cout << "  has cell " << cell << std::endl;
    }

    Import2dMesh mesh2("../../../../geometry/testsuite/Coordinates2D3D.dat",
		       "../../../../geometry/testsuite/Elements2D.dat",
		       "../../../../geometry/testsuite/Dirichlet2D.dat");
    std::cout << mesh2 << std::endl;
    sc.reset(mesh2.scan());
    while (*sc) {
      Cell2& cell = (*sc)++;
      std::cout << "  has cell " << cell << std::endl;
    }

    Import2dMesh mesh3("../../../../geometry/testsuite/Coordinates2D3D.dat",
		       "../../../../geometry/testsuite/Elements2D.dat");
    std::cout << mesh3 << std::endl;
    sc.reset(mesh3.scan());
    while (*sc) {
      Cell2& cell = (*sc)++;
      std::cout << "  has cell " << cell << std::endl;
    }

  }
  catch (ExceptionBase& e) {
    std::cout << e << std::endl;
  }
  
  return 0;
}
