# ####################################################### geometry testsuite ##

project = geometry/testsuite
import = geometry basics toolbox
executable = connTest mesh2D testCell1D testCell2D testCell3D \
	mesh1D testTet subdivTest connectorData meshImp2D meshImp3D hexSubdiv \
	deadlock1 testJacobian meshConverter
object = connTest.o mesh2D.o testCell1D.o testCell2D.o testCell3D.o \
	mesh1D.o testTet.o subdivTest.o connectorData.o \
	meshImp2D.o meshImp3D.o hexSubdiv.o deadlock1.o testJacobian.o \
	meshConverter.o

include $(CONCEPTSDIR)/makesupport/generic.mk

# dependencies
LIBS = -lfl

connTest: connTest.o $(call expand, basics toolbox) geometry/topology.o geometry/connector.o geometry/quadsubdiv.o geometry/strategyChange.o

mesh2D: mesh2D.o $(call expand, geometry basics toolbox)

mesh1D: mesh1D.o $(call expand, geometry basics toolbox)

testCell1D: testCell1D.o $(call expand, basics geometry toolbox)
testCell2D: testCell2D.o $(call expand, basics geometry toolbox)
testCell3D: testCell3D.o $(call expand, basics geometry toolbox)

testTet: testTet.o $(call expand, basics) geometry/topology3D.o geometry/connector.o geometry/topology.o geometry/cell3D.o geometry/elementMaps3D.o geometry/hexsubdiv.o geometry/quadsubdiv.o geometry/mesh.o geometry/strategyChange.o

subdivTest: subdivTest.o $(call expand, basics) geometry/connector.o geometry/topology.o geometry/quadsubdiv.o geometry/strategyChange.o

connectorData: connectorData.o $(call expand, basics geometry toolbox)

meshImp2D: meshImp2D.o $(call expand, basics geometry toolbox)
meshImp3D: meshImp3D.o $(call expand, basics geometry toolbox)

hexSubdiv: hexSubdiv.o $(call expand, basics geometry toolbox)

deadlock1: deadlock1.o $(call expand, basics geometry toolbox)

testJacobian: testJacobian.o $(call expand, geometry basics toolbox)

meshConverter: meshConverter.o $(call expand, geometry basics toolbox)
