/* testsuite for 1D cells
 */

#include "basics/exceptions.hh"
#include "geometry.hh"

int main(int, char**) {

  using namespace concepts;

  try {
    Vertex a(1);
    Vertex b(2);
    Edge c(a, b, 3);
    MapEdge1d d(2.0, 3.0);
    Edge1d e(c, MapEdge1d(2.0, 3.0));

    std::cout << "Edge cell = " << e << std::endl;
    std::cout << "chi(0.25) = " << e.chi(0.25) << std::endl;
    std::cout << "child(0) = " << *(e.child(0)) << std::endl;
    e.child(0)->child(1)->child(0);
    std::cout << "child(1) = " << *(e.child(1)) << std::endl;
  }
  catch (ExceptionBase& e) {
    std::cout << e << std::endl;
  }

  return 0;
}
