/* testsuite for tetrahedron
 */

#include <iostream>
#include "basics.hh"
#include "geometry.hh"

using namespace concepts;

int main(int, char**) {

  Vertex v[4];
  Edge* e[6];

  e[0] = new Edge(v[0], v[1]);
  e[1] = new Edge(v[2], v[1]);
  e[2] = new Edge(v[0], v[2]);
  e[3] = new Edge(v[3], v[0]);
  e[4] = new Edge(v[3], v[1]);
  e[5] = new Edge(v[3], v[2]);

  Triangle* t[4];

  t[0] = new Triangle(*e[0], *e[1], *e[2]);
  t[1] = new Triangle(*e[0], *e[3], *e[4]);
  t[2] = new Triangle(*e[1], *e[4], *e[5]);
  t[3] = new Triangle(*e[2], *e[3], *e[5]);

  Tetrahedron tet(*t[0], *t[1], *t[2], *t[3]);

  std::cout << "tet = " << tet << std::endl;

  MapTetrahedron3d map(Real3d(0.0, 0.0, 0.0),
		       Real3d(1.0, 0.0, 0.0),
		       Real3d(0.0, 1.0, 0.0),
		       Real3d(0.0, 0.0, 1.0));
  Tetrahedron3d tet3(tet, map);

  std::cout << "tet3 = " << tet3 << std::endl;

  for (uint i = 0; i < 4; ++i)
    delete t[i];
  for (uint i = 0; i < 6; ++i)
    delete e[i];

  return 0;
}
