/* Graphics for 1D hp FEM
 */

#ifndef lineGraphics_hh
#define lineGraphics_hh

#include "basics/typedefs.hh"
#include "toolbox/elementGraphics.hh"

namespace hp1D {
  using concepts::Real;

  // ********************************************************** LineGraphics **

  /** Handles graphics for 1D hp FEM elements.
      @author Philipp Frauenfelder, 2002
  */
  class LineGraphics : public concepts::ElementGraphics<Real> {
  public:
    virtual void operator()(const concepts::Element<Real>& elm,
			    enum graphicsType type,
			    concepts::CellPostprocess<Real>& post) const;
  protected:
    virtual std::ostream& info(std::ostream& os) const;
  };

} // namespace hp1D

#endif // lineGraphics_hh
