#include "meshInfo.hh"

#include "geometry.hh"
#include "basics/debug.hh"

#define dgMeshInfo2dConstr_D 0

namespace linDG2D {

  // ************************************************************** MeshInfo **

  MeshInfo::MeshInfo(concepts::Mesh2& mesh) {
    std::auto_ptr<concepts::Scan<concepts::Cell2> > sc(mesh.scan());
    while (*sc) {
      concepts::Cell2& cellB = (*sc)++;
      DEBUGL(dgMeshInfo2dConstr_D, cellB);
      concepts::Triangle2d* cell = dynamic_cast<concepts::Triangle2d*>(&cellB);
      conceptsAssert(cell, concepts::Assertion());
      DEBUGL(dgMeshInfo2dConstr_D, cell);
      concepts::Connector1* edg = 0;
      DEBUGL(dgMeshInfo2dConstr_D, cell->connector());
      DEBUGL(dgMeshInfo2dConstr_D, cell->connector().edge(0));
    
      // for every edge of the cell, the cell is registered in this edge
      for(uint iEdge = 0; (edg = cell->connector().edge(iEdge)) != 0; ++iEdge) {
        EdgeInfo& edgeInfo = edgeInfos_[edg->key()];
        edgeInfo.addCell(cell, iEdge);
      }
    }
  }

}
