#include "basics/testsuite.hh"
#include "basics/exceptions.hh"
#include "elmTest.hh"
#include "edgeInfoTest.hh"
#include "elementPairTest.hh"
#include "spaceTest.hh"

int main(int, char**) {
  //  std::cout << std::setprecision(20);

  test::TestSuite t("DG");

  test::DGTriangleP1Test    t1;        t.addTest(&t1);
  test::DGEdgeInfoTest      t2;        t.addTest(&t2);
  test::DGElementPair2dTest t3;        t.addTest(&t3);
  test::DGSpace2dP1Test     t4;        t.addTest(&t4);

  t.run();

  uint nFailed = t.getNumFailed();
  if (nFailed) {
    t.report();
  } else {
    std::cout << "TestSuite DG: all tests passed" << std::endl;
  }
  return nFailed;
}
