// elements for linear FEM

#include "element.hh"
#include "geometry/connector.hh"
#include "geometry/cell.hh"

namespace linearFEM {

  // *************************************************************** Element **

  Element::Element(concepts::TColumn<Real>* T0, concepts::TColumn<Real>* T1) :
    T_(new concepts::TMatrix<Real>(T1)) {
    if (T0) {
      concepts::TMatrix<Real>* T =
	dynamic_cast<concepts::TMatrix<Real>*>(T_.get());
      conceptsAssert(T, concepts::Assertion());
      T->append(T0);
    }
    // asserts that at least one T column is inserted
    conceptsAssert(T_->m() != 0, concepts::Assertion());
  }

} // namespace linearFEM
