// graphics for quads

#ifndef linQuadGraphics_hh
#define linQuadGraphics_hh

#include "basics/typedefs.hh"
#include "toolbox/elementGraphics.hh"

namespace linearFEM {

  using concepts::Real;

  // ********************************************************** QuadGraphics **

  /** Handles graphics for bilinear quadrilateral FEM elements in 2D.
      @author Philipp Frauenfelder, 2002
  */
  class QuadGraphics : public concepts::ElementGraphics<Real> {
  public:
    virtual void operator()(const concepts::Element<Real>& elm,
			    enum graphicsType type,
			    concepts::CellPostprocess<Real>& post) const;
  protected:
    virtual std::ostream& info(std::ostream& os) const;
  };

} // namespace linearFEM

#endif // linQuadGraphics_hh
