// graphics for tetrahedra

#ifndef linTetrahedronGraphics_hh
#define linTetrahedronGraphics_hh

#include "basics/typedefs.hh"
#include "toolbox/elementGraphics.hh"

namespace linearFEM {

  using concepts::Real;

  // *************************************************** TetrahedronGraphics **

  /** Handles graphics for linear finite elements in 3D: tetrahedra.
      @author Philipp Frauenfelder, 2002
  */
  class TetrahedronGraphics : public concepts::ElementGraphics<Real> {
  public:
    virtual void operator()(const concepts::Element<Real>& elm,
			    enum graphicsType type,
			    concepts::CellPostprocess<Real>& post) const;
  protected:
    virtual std::ostream& info(std::ostream& os) const;
  };

} // namespace linearFEM

#endif // linTetrahedronGraphics_hh
