# ################################################################### builds ##
# calls make in all subdirectories: projects and lib are subdirectories
# which are created before make is called there

SUBDIRS = $(PROJECTS) $(extPROJECTS) $(LIBRARIES) $(APPLICATIONS)

all: $(SUBDIRS) $(addsuffix /Makefile,$(SUBDIRS))
#	@echo $@: $^
	set -e; for i in $(SUBDIRS); do \
	  make -C $$i ;\
	done

lib: $(PROJECTS)
$(APPLICATIONS): lib

$(SUBDIRS):
#	@echo $@: $^
	@mkdir -p $@

$(addsuffix /Makefile,$(LIBRARIES)): \
	  $(addsuffix .mk,$(addprefix $(CONCEPTSDIR)/makesupport/, $(LIBRARIES)))
#	@echo $@: $^
	cp $(CONCEPTSDIR)/makesupport/$(patsubst %/Makefile,%, $@).mk $@

$(addsuffix /Makefile,$(APPLICATIONS)): $(CONCEPTSDIR)/makesupport/applications.mk
#	@echo $@: $^
	cp $(CONCEPTSDIR)/makesupport/applications.mk $(dir $@)Makefile

%/Makefile: $(CONCEPTSDIR)/makesupport/project.mk \
	  $(CONCEPTSDIR)/makesupport/testsuite.mk
#	@echo $@: $^
	@mkdir -p $(dir $@)testsuite
	cp $(CONCEPTSDIR)/makesupport/project.mk $(dir $@)Makefile
	cp $(CONCEPTSDIR)/makesupport/testsuite.mk \
	  $(dir $@)testsuite/Makefile

clean:
	rm -rf $(PROJECTS) $(extPROJECTS) importing
	find . -name '*.o' -exec rm -f {} \;
	find . -name '*.d' -exec rm -f {} \;
	find . -name '*~' -exec rm -f {} \;

distclean: clean
	rm -rf lib $(addprefix lib,$(extPROJECTS)) $(APPLICATIONS)

.PHONY: all $(SUBDIRS)
