use strict;

my $debug = 0;

print STDERR "$0: command line arguments = @ARGV\n", if ($debug);

my $project = shift;
my $filebase = shift;
my $dfile = shift;

my $gotColon = 0;
while (<STDIN>) {
    print STDERR "$0:0: $_", if ($debug);

    # add dependency on .d file
    s|($filebase\.o *):|$1 $dfile:|;
    print STDERR "$0:1: $_", if ($debug);

    # add dependency on .d in the project directory
    s| ([^ /\\][^: ]+).d| $1.d ../$project/$1.d ../../$project/$1.d|g;
    print STDERR "$0:2: $_", if ($debug);

    # do not allow file names after the colon, ie. add a linebreak with '\'
    if (m|: ([^\\]+)|) {
	print STDERR "$0: found file name after colon\n", if ($debug);
	m|(.*):(.*)|;
	print STDOUT $1, ": \\\n";
	$_ = $2 . "\n";
	print STDERR "$0:2b: $_", if ($debug);
	$gotColon = 1;
    }

    # if the colon was already seen on a previous line, add absoulte paths to
    # files without pathnames. This breakes somehow the dependency resolution
    # over intermediate files (eg. bison and flex things). Make has to
    # be called by hand in the respective subdir to rebuild them but no
    # errors in the build process are generated (files in the wrong place or
    # error messages).
    if ($gotColon) {
#	s| ([^ /\\]+)| ../$project/$1|g; # relative paths don't work
	s| ([^ /\\]+)| $ENV{'CONCEPTSDIR'}/builds/$ENV{'config'}/$project/$1|g;
	print STDERR "$0:4: $_", if ($debug);
    }
    $gotColon = 1, if (m|:|);

    print STDOUT;
}

print STDERR "$0: done.\n", if ($debug);
