use strict;

my $debug = 0;

print STDERR "$0: command line arguments = @ARGV\n", if ($debug);
my $pwd = $ENV{'PWD'};
chomp($pwd);
print STDERR "$0: pwd = ", $pwd, "\n", if ($debug);

my $builddir = shift;
$builddir .= "/builds/";
$builddir .= shift;
print STDERR "$0: builddir = $builddir\n", if ($debug);

my $path = `dirname $pwd`;
print STDERR "$0: path = $path\n", if ($debug);
chomp($path);

my $testsuite = `basename $pwd`;
chomp($testsuite);
print STDERR "$0: basename = $testsuite \n", if ($debug);
if ($testsuite eq 'testsuite') {
    # we are in a testsuite subdirectory
    $testsuite = 1;
} else {
    $testsuite = 0;
}
print STDERR "$0: testsuite = $testsuite\n", if ($debug);

#my $extlib = `basename $path`;
#chomp($extlib);
#if ($extlib eq 'lib') {
#    # we are in a extending library subdirectory
#    $extlib = 1;
#} else {
#    $extlib = 0;
#}
#print STDERR "$0: extlib = $extlib\n", if ($debug);

open(OUTPUT, "> importing") or
    die "error while opening " . $pwd . "/importing";
my $import;
foreach $import (@ARGV) {
    my $export = "../$import";
    $export = "../../$import", if ($testsuite);
#    $export = "../../$import", if ($extlib);
    print STDERR "$0: import = $import\n", if ($debug);
    print STDERR "$0: export = $export\n", if ($debug);

    # reading the export file of the project
    open(IMPORT, "$export/export") or
	system("make -C $builddir $import");
    my @lines = <IMPORT>;
    close(IMPORT);
    chomp(@lines);
    print STDERR "$0: lines = @lines\n", if ($debug);

    my $hasDoto = 0;
    # make rule for the .d files as well
    my $doto;
    foreach $doto (@lines) {
	print STDERR "$0: doto = $doto\n", if ($debug);
	$doto =~ s/\s*-l\w+//g;
#	if ($doto =~ s/(\s*)([\w.]+)\.o/$1$import\/$2.o/g) {
#	if ($doto =~ s/(\s*)([\w.]+)\.o/$1$builddir\/$import\/$2.o/g) {
	if ($doto =~ s/(\s*)([\w.]+)\.o/$1$export\/$2.o/g) {
#	if ($doto =~ s/(\s*)([\w.]+)\.o/$1$import\/$2.o/g) {
	    $hasDoto = 1;
	}
	print STDERR "$0: doto = $doto\n", if ($debug);

	my $output = $doto;
	if ($output =~ s/\.o\b/.d \\\n/g) {
	    print OUTPUT "$output";
	}
    }
    print STDERR "$0: lines = @lines\n", if ($debug);
    if ($hasDoto) {
#	foreach $doto (@lines) {
#	    print OUTPUT " $doto \\\n";
#	}
	print OUTPUT " :\n";
	print OUTPUT "\tmake -C $export export\n";
    }

    # including .d files
    foreach $doto (@lines) {
	my $output = $doto;
	print STDERR "$0: output = $output\n", if ($debug);
	if ($output =~ s/\s*([\w.\-\/]+)\.o/-include $1.d\n/g) {
	    print STDERR "$0: output = $output\n", if ($debug);
	    print OUTPUT "$output";
	} else {
	    print STDERR "$0: no .o files\n", if ($debug);
#	    print OUTPUT "-include ../$import/importing\n";
#	    print OUTPUT ".PHONY: $output\n";
	}
    }

    print OUTPUT "\n";
}
close(OUTPUT);
