# ########################################## configuration sun4u-solaris-gnu ##

PERL = /usr/local/bin/perl

SHELL = /bin/sh

CC = gcc.old
CXX = g++.old
D = $(CC) -MM $(CPPFLAGS)
RM = /bin/rm
MV = /bin/mv

FLEX=flex
YACC=bison
YFLAGS=-d -t -v

LIBSUFFIX = a
LDRPATH = -Wl,-R,

DEBUG = -O2 -fpic
CFLAGS = -g -Wall $(DEBUG)
CXXFLAGS = -g -Wall $(DEBUG)
LDFLAGS = -s -L$(CONCEPTSDIR)/builds/$(config)/lib -L/usr/local/lib # -fpic

ifeq ($(HAS_PETSC),true)
LDFLAGS += $(LDRPATH)$(PETSC_LIB_PATH) -L$(PETSC_LIB_PATH) \
	-L/usr/local/app/petsc/lapack
endif

ifeq ($(HAS_SuperLU),true)
LDFLAGS += -L$(SuperLU_LIB_PATH)
endif

ifeq ($(HAS_JDBSym),true)
LDFLAGS += -L$(JDBSym_LIB_PATH)
endif

%.a.$(VERSION):
	ar r $@ $^
	ranlib $@
	-ln -sf $@ $(@:.$(VERSION)=.$(MAJOR))
	-ln -sf $(@:.$(VERSION)=.$(MAJOR)) $(@:.a.$(VERSION)=.a)

%.so.$(VERSION):
	$(CXX) -fno-gnu-linker -Wl,-G,-h,$@.$(MAJOR) $(LDFLAGS) \
	  -o $@ $(LDFLAGS) $^
	-ln -sf $@ $(@:.$(VERSION)=.$(MAJOR))
	-ln -sf $(@:.$(VERSION)=.$(MAJOR)) $(@:.so.$(VERSION)=.so)
