# ############################### configuration sun4u-solaris-workshop-debug ##

PERL = /usr/local/bin/perl

SHELL = /bin/sh

CC = cc
CXX = CC
D = $(CXX) -xM1 $(CPPFLAGS)
RM = /bin/rm
MV = /bin/mv

FLEX=flex
YACC=bison
YFLAGS=-d -t -v

LIBSUFFIX = a
LDRPATH = -R

DEBUG = -g +w2 -xO0
CPPFLAGS += -D__EXTENSIONS__ -DDEBUG
CFLAGS = $(DEBUG)
CXXFLAGS = $(DEBUG) -features=extensions
LDFLAGS = -L$(CONCEPTSDIR)/builds/$(config)/lib
CPPFLAGS += -I/usr/local.hg/opt/SUNWspro/WS6U2/include/CC/../CCios

# HAS_PETSC = false
ifeq ($(HAS_PETSC),true)
export PETSC_ARCH = solaris_workshop
LDFLAGS += $(LDRPATH)$(PETSC_LIB_PATH) -L$(PETSC_LIB_PATH)
endif

VPATH = /usr/local/lib

%.a.$(VERSION):
	CC -xar -o $@ $^
	-ln -sf $@ $(@:.$(VERSION)=.$(MAJOR))
	-ln -sf $(@:.$(VERSION)=.$(MAJOR)) $(@:.a.$(VERSION)=.a)

# LAPACK
LAPACK_LIB = -lsunperf -lF77 -lfui -lfai -lfai2 -lfsumai -lfprodai -lfminlai -lfmaxlai -lfminvai -lfmaxvai -lfsu -lsunmath

# STLport
HAS_STLport = true
ifeq ($(HAS_STLport),true)
STLport_PATH = $(CONCEPTSDIR)/../STLport/STLport-4.5.3
STLport_PATH_INC_PATH = $(STLport_PATH)/stlport
STLport_PATH_LIB_PATH = $(STLport_PATH)/lib
CXXFLAGS += -DHAS_STLport -I$(STLport_PATH_INC_PATH)
D += -DHAS_STLport -I$(STLport_PATH_INC_PATH)
LDFLAGS += $(LDRPATH)$(STLport_PATH_LIB_PATH) -L$(STLport_PATH_LIB_PATH) -library=no%Cstd -lstlport_sunpro
endif

# SuperLU - sparse direct solver
HAS_SuperLU = true
ifeq ($(HAS_SuperLU),true)
SuperLU_PATH = /scratch/localsam/SRC/SuperLU/SuperLU
# SuperLU_LIB_PATH =
SuperLU_INC_PATH = $(SuperLU_PATH)/SRC
CPPFLAGS += -DHAS_SuperLU -I$(SuperLU_INC_PATH)
SuperLU_LIB = -lsuperlu $(LAPACK_LIB)
endif

# JDBSYM - eigenvalue solver
HAS_JDBSym = true
ifeq ($(HAS_JDBSym),true)
JDBSym_PATH = /scratch/localsam/SRC/jdbsym/jdbsym-0.14
# JDBSym_LIB_PATH =
JDBSym_INC_PATH = $(JDBSym_PATH)
JDBSym_LIB = -ljdbsym -ljdqrgen $(LAPACK_LIB)
endif

# ARPACK - eigenvalue solver
HAS_ARPACK = true
ifeq ($(HAS_ARPACK),true)
ARPACK_PATH = /scratch/localsam/SRC/ARPACK/ARPACK
# ARPACK_LIB_PATH =
ARPACK_LIB = -larpack $(LAPACK_LIB)
endif

# PETSc - iterative solvers and much more
ifeq ($(HAS_PETSC),true)
export PETSC_ARCH = solaris_workshop_64
LDFLAGS += $(LDRPATH)$(PETSC_LIB_PATH) -L$(PETSC_LIB_PATH)
endif

# UMFPACK - sparse direct solver
HAS_UMFPACK = true
ifeq ($(HAS_UMFPACK),true)
UMFPACK_PATH = /scratch/localsam/SRC/UMFPACK/umfpack-4.1
UMFPACK_LIB_PATH = .
UMFPACK_LIB = -lumfpack -lamd
UMFPACK_INC_PATH = $(UMFPACK_PATH)/UMFPACK/Include
CPPFLAGS += -DUMFPACK_41
endif

# PARDISO - sparse direct solver
HAS_PARDISO = true
ifeq ($(HAS_PARDISO),true)
PARDISO_PATH = /scratch/localsam/SRC/PARDISO
PARDISO_LIB_PATH = $(PARDISO_PATH)/lib
PARDISO_LIB = -lpardiso -lmetis -L/usr/local.hg/opt/SUNWspro/WS6U2/lib/v9 -lmtsk -lthread
PARDISO_INC_PATH = $(PARDISO_PATH)
endif
