# ################################################################# operator ##

project = operator
import = basics space function toolbox sparseqr
object = compositionsR.o compositionsC.o denseMatrixR.o denseMatrixC.o \
	bilinearForm.o cg.o matrixR.o matrixC.o diagonalR.o diagonalC.o \
	sparseMatrix_R.o hashedSMatrix_R.o sparseMatrix_C.o hashedSMatrix_C.o \
	gmresR.o gmresC.o permutationR.o permutationC.o transpose.o \
	constrained.o

all:

ifeq ($(HAS_PETSC),true)
object += PETSc.o
include $(PETSC_DIR)/bmake/common/base
CPPFLAGS += $(PETSC_INCLUDE)
  ifeq ($(findstring prof,$(config)),prof)
  COPTFLAGS := $(filter-out -fomit-frame-pointer,$(COPTFLAGS))
  endif
COPTFLAGS := $(filter-out -Wshadow,$(COPTFLAGS))
.cc.o:
	$(CXX) -c $(CPPFLAGS) $(CXXFLAGS) $<
endif

ifeq ($(HAS_SuperLU),true)
object += superLU.o
CPPFLAGS += -I$(SuperLU_INC_PATH)
endif

ifeq ($(HAS_NRLsolver),true)
object += nrlSolver.o
CPPFLAGS += -I$(NRLsolver_INC_PATH)
endif

ifeq ($(HAS_UMFPACK),true)
object += umfpack.o
CPPFLAGS += -I$(UMFPACK_INC_PATH)
endif

ifeq ($(HAS_SPOOLES),true)
object += spooles.o
CPPFLAGS += -I$(SPOOLES_INC_PATH)
endif

ifeq ($(HAS_PARDISO),true)
object += pardiso.o
CPPFLAGS += -I$(PARDISO_INC_PATH)
endif

$(shell rm -f libraries)

ifeq ($(HAS_PETSC),true)
$(shell echo $(PETSC_SLES_LIB) >> libraries)
endif

ifeq ($(HAS_SuperLU),true)
$(shell echo -L$(SuperLU_LIB_PATH) $(SuperLU_LIB) >> libraries)
endif

ifeq ($(HAS_NRLsolver),true)
$(shell echo -L$(NRLsolver_LIB_PATH) $(NRLsolver_LIB) >> libraries)
endif

ifeq ($(HAS_UMFPACK),true)
$(shell echo -L$(UMFPACK_LIB_PATH) $(UMFPACK_LIB) >> libraries)
endif

ifeq ($(HAS_SPOOLES),true)
$(shell echo -L$(SPOOLES_LIB_PATH) $(SPOOLES_LIB) >> libraries)
endif

ifeq ($(HAS_PARDISO),true)
$(shell echo -L$(PARDISO_LIB_PATH) $(PARDISO_LIB) >> libraries)
endif

$(shell echo $(LAPACK_LIB) >> libraries)

include $(CONCEPTSDIR)/makesupport/$(config).mk
include $(CONCEPTSDIR)/makesupport/generic.mk
