/* A sparse matrix
 */

#include "basics/typedefs.hh"
#include "sparseMatrix.cc"

namespace concepts {

  template<>
  void SparseMatrix<Cmplx>::histogram(std::map<int, uint>& hist) const {
    int hashBits = m_->HashBits();
    int p = 1 << hashBits;
    uint n = spaceX().dim();
    HashedSparseMatrix<Cmplx>::Value** matrix = m_->Matrix();

    for (uint r = 0; r < n; ++r) {
      for (int c_mod = 0; c_mod < p; ++c_mod) {
	for (HashedSparseMatrix<Cmplx>::Value* v =
	       matrix[(r<<hashBits) + c_mod]; v != NULL; v = v->lnk) {
	  if (v->val != 0.0) {
	    ++(hist[(int)(std::ceil(std::log10(std::fabs(abs(v->val)))))]);
	  }
	}
      }
    }
  }

  template class SparseMatrix<Cmplx>;
}
