# ####################################################### operator testsuite ##

project = operator/testsuite
import = basics operator space function toolbox sparseqr
executable = denseMatrix matrixTest gmresTest permutation cgTest sparseMatrix \
	hashedMatrix compositions
object = denseMatrix.o matrixTest.o gmresTest.o permutation.o cgTest.o \
	sparseMatrix.o hashedMatrix.o compositions.o

ifeq ($(HAS_PETSC),true)
executable += petsc
object += petsc.o
endif

ifeq ($(HAS_NRLsolver),true)
executable += nrlSolver
object += nrlSolver.o
endif

ifeq ($(HAS_UMFPACK),true)
executable += umfpackTest
object += umfpackTest.o
endif

ifeq ($(HAS_SPOOLES),true)
executable += spoolesTest
object += spoolesTest.o
endif

ifeq ($(HAS_PARDISO),true)
executable += pardisoTest pardiso_sym_64bit pardiso_unsym_64bit
object += pardisoTest.o pardiso_sym_64bit.o pardiso_unsym_64bit.o
endif

ifeq ($(HAS_UMFPACK),true)
executable += superLUtest
object += superLUtest.o
endif

include $(CONCEPTSDIR)/makesupport/generic.mk

toolbox_o =  toolbox/resourceMonitor.o toolbox/inputOutput.o toolbox/input.yy.o toolbox/input.tab.o

# dependencies
matrixTest: LIBS = $(call extractLibs,$(shell cat ../libraries)) -lfl
matrixTest: matrixTest.o $(call expand, basics operator space function $(toolbox_o))

gmresTest: LIBS = $(call extractLibs,$(shell cat ../libraries)) -lfl
gmresTest: gmresTest.o $(call expand, basics operator space function $(toolbox_o))

permutation: LIBS = $(call extractLibs,$(shell cat ../libraries)) -lfl
permutation: permutation.o $(call expand, basics operator space function $(toolbox_o))

denseMatrix: LIBS = $(call extractLibs,$(shell cat ../libraries)) -lfl
denseMatrix: denseMatrix.o $(call expand, basics operator space function $(toolbox_o))

petsc: LIBS = $(call extractLibs,$(shell cat ../libraries)) -lfl
petsc: petsc.o $(call expand, basics operator space function $(toolbox_o))

cgTest: LIBS = $(call extractLibs,$(shell cat ../libraries)) -lfl
cgTest: cgTest.o $(call expand, basics operator space function $(toolbox_o))

nrlSolver: LIBS = $(call extractLibs,$(shell cat ../libraries)) -lfl
nrlSolver: nrlSolver.o $(call expand, basics operator space function $(toolbox_o))

umfpackTest: LIBS = $(call extractLibs,$(shell cat ../libraries)) -lfl
umfpackTest: umfpackTest.o $(call expand, basics operator space function $(toolbox_o))

spoolesTest: LIBS = $(call extractLibs,$(shell cat ../libraries)) -lfl
spoolesTest: spoolesTest.o $(call expand, basics operator space function $(toolbox_o))

pardisoTest: LIBS = $(call extractLibs,$(shell cat ../libraries)) -lfl
pardisoTest: pardisoTest.o $(call expand, basics operator space function $(toolbox_o))

pardiso_sym_64bit: LIBS = $(call extractLibs,$(shell cat ../libraries))
pardiso_sym_64bit: pardiso_sym_64bit.o

pardiso_unsym_64bit: LIBS = $(call extractLibs,$(shell cat ../libraries))
pardiso_unsym_64bit: pardiso_unsym_64bit.o

sparseMatrix: LIBS = $(call extractLibs,$(shell cat ../libraries)) -lfl
sparseMatrix: sparseMatrix.o $(call expand, basics operator space function $(toolbox_o))

hashedMatrix: LIBS = $(call extractLibs,$(shell cat ../libraries)) -lfl
hashedMatrix: hashedMatrix.o $(call expand, basics operator space function $(toolbox_o))

superLUtest: LIBS = $(call extractLibs,$(shell cat ../libraries)) -lfl
superLUtest: superLUtest.o $(call expand, basics operator space function $(toolbox_o))

compositions: LIBS = $(call extractLibs,$(shell cat ../libraries)) -lfl
compositions: compositions.o $(call expand, basics space function operator $(toolbox_o) sparseqr)