/* testsuite for SparseMatrix
 */

#include "basics/exceptions.hh"
#include "operator/sparseMatrix.hh"
#include "operator/denseMatrix.hh"

using namespace concepts;

int main(int argc, char** argv) {

  try {
    DummySpace<Real> spc1(4);
    std::cout << spc1 << std::endl;
    SparseMatrix<Real> m(spc1, spc1);
    m(0,0) = 1; m(0,1) = 1;
    m(1,1) = 1; m(2,2) = 1;
    m(2,3) = 1; m(3,1) = 1;
    m(3,3) = 1;
    std::cout << m << " = " << DenseMatrix<Real>(m) << std::endl;
    m.symmetrize();
    std::cout << m << " = " << DenseMatrix<Real>(m) << std::endl;
  }
  catch (ExceptionBase& e) {
    std::cout << e << std::endl;
  }

  return 0;
}
