/* testing array
 */

#include "basics/exceptions.hh"
#include "toolbox/array.hh"

int main(int, char**) {

  using namespace concepts;

  try {
    Array<double> a;
    std::cout << a << std::endl;
    a.resize(10);
    for (uint i = 0; i < 10; i++)
      a[i] = i;
    std::cout << a << std::endl;
    a.zeros();
    std::cout << a << std::endl;
    std::cout << "Memory: " << a.memory() << std::endl;
    a.resize(5);
    for (uint i = 0; i < 5; i++)
      a[i] = i;
    std::cout << a << std::endl;
    std::cout << "Memory: " << a.memory() << std::endl;
    a.resize(200); a.zeros();
    std::cout << a << std::endl;
    std::cout << "Memory: " << a.memory() << std::endl;
  }
  catch (ExceptionBase& e) {
    std::cout << e << std::endl;
  }

  return 0;
}
