/* testing CoeffIterator
 */

#include "basics/typedefs.hh"
#include "basics/exceptions.hh"
#include "basics/vectorsMatrices.hh"
#include "toolbox/coeffIterator.hh"

int main(int, char**) {

  using namespace concepts;

  try {
    const uint n = 5;
    Real a[n];
    for (uint i = 0; i < n; ++i)
      a[i] = i+(Real)i/10.0;
    MapReal3d c[n];

    CoeffIterator<Real, Real> b(a);
    CoeffIterator<Real, MapReal3d> d(c, 1, 1);

    for (uint i = 0; i < n; ++i) {
      c[i] = MapReal3d(1.0*i, 2.0*i, 3.0*i,
		       4.0*i, 5.0*i, 6.0*i,
		       7.0*i, 8.0*i, 9.0*i);
      std::cout << c[i] << std::endl;
    }
    std::cout << std::endl;

    for (uint i = 0; i < n; ++i)
      std::cout << a[i] << " = " << *b++ << ", ";
    std::cout << std::endl;

    for (uint i = 0; i < n; ++i)
      std::cout << *d++ << ", ";
    std::cout << std::endl;
  }
  catch (ExceptionBase& e) {
    std::cout << e << std::endl;
  }

  return 0;
}
