/* testing Formula, Boundary, BoundaryConditions
 */

#include <iostream>
#include "basics/exceptions.hh"
#include "geometry/connector.hh"
#include "geometry/boundaryConditions.hh"
#include "toolbox/formula.hh"
#include "toolbox/boundary.hh"

int main(int, char**) {

  using namespace concepts;

  try {
    ParsedFormula a("(x+y)");
    std::cout << a << std::endl;

    Boundary b(Boundary::DIRICHLET, a);
    std::cout << b << std::endl;

    BoundaryConditions c;
    c.add(Attribute(1), b);

    c.add(Attribute(2), Boundary(Boundary::NEUMANN));
    c.add(Attribute(3), Boundary(Boundary::NEUMANN, "(x)"));

    std::cout << c << std::endl;
  }
  catch (ExceptionBase& e) {
    std::cout << e << std::endl;
  }

  return 0;
}
