// graphics for vector valued elements

#include "basics/typedefs.hh"
#include "basics/exceptions.hh"
#include "vectorial/graphics.hh"
#include "vectorial/vectorial.hh"
#include "space/postProcess.hh"

// debuggig
#include "basics/debug.hh"

#define GraphicsAppl_D 0

namespace vectorial {

  // ************************************************************** Graphics **

  template<typename F>
  void Graphics<F>::operator()
    (const concepts::Element<F>& elm,
     typename concepts::ElementGraphics<F>::graphicsType type,
     concepts::CellPostprocess<F>& post) const {
    DEBUGL(GraphicsAppl_D, elm);
    const Element<F>* e =
      dynamic_cast<const Element<F>*>(&elm);
    conceptsAssert(e != 0, concepts::Assertion());
    const concepts::Element<F>& scalarElm = *(e->get(idx_));
    DEBUGL(GraphicsAppl_D, "extracted " << idx_ << ": " << scalarElm);
    scalarElm.graphics()->operator()(scalarElm, type, post);
  }

  template<typename F>
  std::ostream& Graphics<F>::info(std::ostream& os) const {
    return os << "vectorial::Graphics()";
  }

  template class Graphics<concepts::Real>;

} // namespace vectorial
